# fixpoint-openapi
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: version not set
- Package version: 0.1.0
- Generator version: 7.4.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import fixpoint_openapi
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import fixpoint_openapi
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import fixpoint_openapi
from fixpoint_openapi.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = fixpoint_openapi.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with fixpoint_openapi.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = fixpoint_openapi.FixpointApi(api_client)
    body = fixpoint_openapi.V1CreateApiSecretRequest() # V1CreateApiSecretRequest | 

    try:
        # Store LLM inference API secret
        api_response = api_instance.fixpoint_create_api_secret(body)
        print("The response of FixpointApi->fixpoint_create_api_secret:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling FixpointApi->fixpoint_create_api_secret: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*FixpointApi* | [**fixpoint_create_api_secret**](docs/FixpointApi.md#fixpoint_create_api_secret) | **POST** /v1/api_secrets | Store LLM inference API secret
*FixpointApi* | [**fixpoint_create_app_logs**](docs/FixpointApi.md#fixpoint_create_app_logs) | **POST** /v1/app_logs | Create application logs
*FixpointApi* | [**fixpoint_create_dataset**](docs/FixpointApi.md#fixpoint_create_dataset) | **POST** /v1/datasets | Create LLM dataset
*FixpointApi* | [**fixpoint_create_likes**](docs/FixpointApi.md#fixpoint_create_likes) | **POST** /v1/likes | Add LLM log feedback (\&quot;likes\&quot;)
*FixpointApi* | [**fixpoint_create_log_attribute**](docs/FixpointApi.md#fixpoint_create_log_attribute) | **POST** /v1/attributes | Attach attribute to LLM log
*FixpointApi* | [**fixpoint_create_multi_llm_chat_completion**](docs/FixpointApi.md#fixpoint_create_multi_llm_chat_completion) | **POST** /v1/chat/completions/multi_llm | 
*FixpointApi* | [**fixpoint_create_open_ai_chat_input_log**](docs/FixpointApi.md#fixpoint_create_open_ai_chat_input_log) | **POST** /v1/openai_chats/{modelName}/input_logs | Create an LLM input log
*FixpointApi* | [**fixpoint_create_open_ai_chat_output_log**](docs/FixpointApi.md#fixpoint_create_open_ai_chat_output_log) | **POST** /v1/openai_chats/{modelName}/output_logs | Create an LLM output log
*FixpointApi* | [**fixpoint_create_routing_config**](docs/FixpointApi.md#fixpoint_create_routing_config) | **POST** /v1/routing_configs | Create LLM routing config
*FixpointApi* | [**fixpoint_delete_log_attribute**](docs/FixpointApi.md#fixpoint_delete_log_attribute) | **DELETE** /v1/attributes/{name} | Remove LLM log attribute
*FixpointApi* | [**fixpoint_list_api_secrets**](docs/FixpointApi.md#fixpoint_list_api_secrets) | **GET** /v1/api_secrets | List LLM inference API secrets
*FixpointApi* | [**fixpoint_list_app_logs**](docs/FixpointApi.md#fixpoint_list_app_logs) | **GET** /v1/app_logs | List application logs
*FixpointApi* | [**fixpoint_list_datasets**](docs/FixpointApi.md#fixpoint_list_datasets) | **GET** /v1/datasets | List LLM datasets
*FixpointApi* | [**fixpoint_list_likes**](docs/FixpointApi.md#fixpoint_list_likes) | **GET** /v1/likes | List LLM log feedback (\&quot;likes\&quot;)
*FixpointApi* | [**fixpoint_list_log_attributes**](docs/FixpointApi.md#fixpoint_list_log_attributes) | **GET** /v1/attributes | List attributes on an LLM log
*FixpointApi* | [**fixpoint_list_open_ai_chat_logs**](docs/FixpointApi.md#fixpoint_list_open_ai_chat_logs) | **GET** /v1/{parent}/logs | DEPRECATED: List LLM logs
*FixpointApi* | [**fixpoint_list_routing_configs**](docs/FixpointApi.md#fixpoint_list_routing_configs) | **GET** /v1/routing_configs | List LLM routing configs
*FixpointApi* | [**fixpoint_post_dataset_logs**](docs/FixpointApi.md#fixpoint_post_dataset_logs) | **POST** /v1/datasets/{name}/logs | Add logs to a dataset
*FixpointApi* | [**fixpoint_update_spending_totals**](docs/FixpointApi.md#fixpoint_update_spending_totals) | **PATCH** /v1/routing_configs/{routeConfigId} | Update routing config spending totals


## Documentation For Models

 - [AppLogLevelType](docs/AppLogLevelType.md)
 - [FixpointCreateOpenAIChatInputLogRequest](docs/FixpointCreateOpenAIChatInputLogRequest.md)
 - [FixpointCreateOpenAIChatOutputLogRequest](docs/FixpointCreateOpenAIChatOutputLogRequest.md)
 - [FixpointPostDatasetLogsRequest](docs/FixpointPostDatasetLogsRequest.md)
 - [FixpointUpdateSpendingTotalsRequest](docs/FixpointUpdateSpendingTotalsRequest.md)
 - [Fixpointv1Model](docs/Fixpointv1Model.md)
 - [ProtobufAny](docs/ProtobufAny.md)
 - [ProtobufNullValue](docs/ProtobufNullValue.md)
 - [RpcStatus](docs/RpcStatus.md)
 - [ToolCallFunction](docs/ToolCallFunction.md)
 - [V1ApiSecret](docs/V1ApiSecret.md)
 - [V1ApiSecretProvider](docs/V1ApiSecretProvider.md)
 - [V1AppLog](docs/V1AppLog.md)
 - [V1AttributeFilters](docs/V1AttributeFilters.md)
 - [V1ChatCompletion](docs/V1ChatCompletion.md)
 - [V1ChatCompletionChoice](docs/V1ChatCompletionChoice.md)
 - [V1ChatCompletionUsage](docs/V1ChatCompletionUsage.md)
 - [V1CreateApiSecretRequest](docs/V1CreateApiSecretRequest.md)
 - [V1CreateAppLogsRequest](docs/V1CreateAppLogsRequest.md)
 - [V1CreateAppLogsResponse](docs/V1CreateAppLogsResponse.md)
 - [V1CreateDatasetRequest](docs/V1CreateDatasetRequest.md)
 - [V1CreateDatasetResponse](docs/V1CreateDatasetResponse.md)
 - [V1CreateLikesRequest](docs/V1CreateLikesRequest.md)
 - [V1CreateLikesResponse](docs/V1CreateLikesResponse.md)
 - [V1CreateLogAttributeRequest](docs/V1CreateLogAttributeRequest.md)
 - [V1CreateLogAttributeResponse](docs/V1CreateLogAttributeResponse.md)
 - [V1CreateMultiLLMChatCompletionRequest](docs/V1CreateMultiLLMChatCompletionRequest.md)
 - [V1CreateMultiLLMChatCompletionRequestModel](docs/V1CreateMultiLLMChatCompletionRequestModel.md)
 - [V1CreateRoutingConfigRequest](docs/V1CreateRoutingConfigRequest.md)
 - [V1Dataset](docs/V1Dataset.md)
 - [V1DatasetFilters](docs/V1DatasetFilters.md)
 - [V1DeleteLogAttributeResponse](docs/V1DeleteLogAttributeResponse.md)
 - [V1FallbackStrategy](docs/V1FallbackStrategy.md)
 - [V1InputMessage](docs/V1InputMessage.md)
 - [V1Like](docs/V1Like.md)
 - [V1LikeFilter](docs/V1LikeFilter.md)
 - [V1LikeIngest](docs/V1LikeIngest.md)
 - [V1ListApiSecretsResponse](docs/V1ListApiSecretsResponse.md)
 - [V1ListAppLogsResponse](docs/V1ListAppLogsResponse.md)
 - [V1ListDatasetsResponse](docs/V1ListDatasetsResponse.md)
 - [V1ListLikesResponse](docs/V1ListLikesResponse.md)
 - [V1ListLogAttributesResponse](docs/V1ListLogAttributesResponse.md)
 - [V1ListOpenAIChatLogsResponse](docs/V1ListOpenAIChatLogsResponse.md)
 - [V1ListRoutingConfigsResponse](docs/V1ListRoutingConfigsResponse.md)
 - [V1LogAttribute](docs/V1LogAttribute.md)
 - [V1Mode](docs/V1Mode.md)
 - [V1MultiLLMChatCompletion](docs/V1MultiLLMChatCompletion.md)
 - [V1OpenAIChatInputLog](docs/V1OpenAIChatInputLog.md)
 - [V1OpenAIChatLog](docs/V1OpenAIChatLog.md)
 - [V1OpenAIChatLogsFilters](docs/V1OpenAIChatLogsFilters.md)
 - [V1OpenAIChatOutputLog](docs/V1OpenAIChatOutputLog.md)
 - [V1OpenAIChatOutputLogChoice](docs/V1OpenAIChatOutputLogChoice.md)
 - [V1OpenAIChatOutputLogUsage](docs/V1OpenAIChatOutputLogUsage.md)
 - [V1OriginType](docs/V1OriginType.md)
 - [V1OutputMessage](docs/V1OutputMessage.md)
 - [V1PostDatasetLogsResponse](docs/V1PostDatasetLogsResponse.md)
 - [V1RelativeDateTimeFilters](docs/V1RelativeDateTimeFilters.md)
 - [V1ResetInterval](docs/V1ResetInterval.md)
 - [V1RoutingConfig](docs/V1RoutingConfig.md)
 - [V1SpendCap](docs/V1SpendCap.md)
 - [V1TerminalState](docs/V1TerminalState.md)
 - [V1ThumbsReaction](docs/V1ThumbsReaction.md)
 - [V1ToolCall](docs/V1ToolCall.md)
 - [V1Tracing](docs/V1Tracing.md)
 - [V1TracingFilters](docs/V1TracingFilters.md)
 - [V1UsageTotals](docs/V1UsageTotals.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




