# coding: utf-8

"""
    fixpoint/v1/service.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class V1Tracing(BaseModel):
    """
    A session ties together multiple chat completions for a user or system session. For example, when a user logs into ChatGPT and has a conversation, that whole conversation thread is called a session.  A trace represents a chain of inference requests. Think similarly to OpenTelemetry and OpenTracing. A session can have multiple traces. The difference, is that the trace is one \"request\" from an end-user that might have multiple inference calls, while a \"session\" consists of multiple inference requests.  A trace contains multiple spans, which are one step of the trace.
    """ # noqa: E501
    session_id: Optional[StrictStr] = Field(default=None, alias="sessionId")
    trace_id: Optional[StrictStr] = Field(default=None, alias="traceId")
    span_id: Optional[StrictStr] = Field(default=None, alias="spanId")
    parent_span_id: Optional[StrictStr] = Field(default=None, alias="parentSpanId")
    __properties: ClassVar[List[str]] = ["sessionId", "traceId", "spanId", "parentSpanId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1Tracing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1Tracing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sessionId": obj.get("sessionId"),
            "traceId": obj.get("traceId"),
            "spanId": obj.get("spanId"),
            "parentSpanId": obj.get("parentSpanId")
        })
        return _obj


