# coding: utf-8

"""
    fixpoint/v1/service.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class V1TracingFilters(BaseModel):
    """
    Filter LLM logs to session, trace, or span info.  The top-level filter attributes (session_ids, trace_ids, etc.) combine with the \"AND\" filter, // while within a given field such as \"session_ids\", the items combine with the \"OR\" filter.  For example:    TracingFilters = {     session_ids: [\"session1\", \"session2\"],     trace_ids: [\"trace1\", \"trace2\"],   }  This will match all LLM logs that have either \"session1\" or \"session2\", and who also have either \"trace1\" or \"trace2\".
    """ # noqa: E501
    session_ids: Optional[List[StrictStr]] = Field(default=None, alias="sessionIds")
    trace_ids: Optional[List[StrictStr]] = Field(default=None, alias="traceIds")
    span_ids: Optional[List[StrictStr]] = Field(default=None, alias="spanIds")
    parent_span_ids: Optional[List[StrictStr]] = Field(default=None, alias="parentSpanIds")
    __properties: ClassVar[List[str]] = ["sessionIds", "traceIds", "spanIds", "parentSpanIds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1TracingFilters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1TracingFilters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sessionIds": obj.get("sessionIds"),
            "traceIds": obj.get("traceIds"),
            "spanIds": obj.get("spanIds"),
            "parentSpanIds": obj.get("parentSpanIds")
        })
        return _obj


